#ifndef HYDROGEN_CONFIG_H
#define HYDROGEN_CONFIG_H

#define HYDROGEN_VERSION_MAJOR "1"
#define HYDROGEN_VERSION_MINOR "3"
#define HYDROGEN_VERSION_PATCH "3"

#define HYDROGEN_RELEASE_BUILD

// LAPACK stuff
#define HYDROGEN_BLAS_SUFFIX _
#define HYDROGEN_LAPACK_SUFFIX _

// 16-bit floating point stuff
/* #undef HYDROGEN_HAVE_HALF */
/* #undef HYDROGEN_HAVE_BFLOAT16 */

// Extended Precision stuff
/* #undef HYDROGEN_HAVE_QUADMATH */
/* #undef HYDROGEN_HAVE_QD */
/* #undef HYDROGEN_HAVE_MPC */

#define HYDROGEN_HAVE_LAPACK

// MKL stuff
/* #undef HYDROGEN_HAVE_MKL */
/* #undef HYDROGEN_HAVE_MKL_GEMMT */

// CUDA stuff
/* #undef HYDROGEN_HAVE_CUDA */
/* #undef HYDROGEN_HAVE_CUB */
/* #undef HYDROGEN_CUBLAS_USE_TENSOR_OP_MATH */

// General GPU stuff
#ifdef HYDROGEN_HAVE_CUDA
#define HYDROGEN_HAVE_GPU
/* #undef HYDROGEN_GPU_USE_FP16 */
#endif // HYDROGEN_HAVE_CUDA

// Aluminum stuff
/* #undef HYDROGEN_HAVE_ALUMINUM */
/* #undef HYDROGEN_HAVE_NCCL2 */
/* #undef HYDROGEN_HAVE_AL_MPI_CUDA */

#define HYDROGEN_ENSURE_HOST_MPI_BUFFERS
/* #undef HYDROGEN_HAVE_CUDA_AWARE_MPI */
/* #undef HYDROGEN_MPI_IS_OPENMPI */
/* #undef HYDROGEN_MPI_IS_MVAPICH2 */

/* #undef HYDROGEN_HAVE_OMP_TASKLOOP */

/* #undef HYDROGEN_HAVE_NVPROF */
/* #undef HYDROGEN_HAVE_VTUNE */
/* #undef HYDROGEN_DEFAULT_SYNC_PROFILING */

/* #undef HYDROGEN_DO_BOUNDS_CHECKING */

#endif /* HYDROGEN_CONFIG_H */
